<?php
/*
Plugin Name: Recent Post Views
Plugin URI: http://cbuckconsulting.com/recent-post-views/
Description: Displays the most recent posts in a widget, and how many times each has been viewed in the sidebar, along with snazzy images for the "hottest" posts.
Version: 0.1
Author: ChrisBuck
Author URI: http://cbuckconsulting.com
License: GPL2
*/

/*  Copyright 2012  Chris Buck  (email : Chris@CBuckConsulting.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//Add shortcode functionality. Coming soon.

//Add a widget.

class recentPostViews_Widget extends WP_Widget
{
  function recentPostViews_Widget()
  {
    $widget_ops = array('classname' => 'recentPostViews_Widget', 'description' => 'Allows you to display recent posts, with the number of views, in the sidebar.');
    $this->WP_Widget('recentPostViews_Widget', 'Recent Post Views', $widget_ops);
  }
 
  function form($instance)
  {
    $instance = wp_parse_args((array) $instance, array( 'title' => '' ));
    $title = $instance['title'];

?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>">Title: <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></label></p>
<?php
  }
 
  function update($new_instance, $old_instance)
  {
    $instance = $old_instance;
    $instance['title'] = $new_instance['title'];
    return $instance;
  }
 
  function widget($args, $instance)
  {
    extract($args, EXTR_SKIP);
 
    echo $before_widget;
    $title = empty($instance['title']) ? '' : apply_filters('widget_title', $instance['title']);
 
    if (!empty($title))
      echo $before_title . $title . $after_title;;
 
    // Widget Stuff Goes Here...

//Preliminary housekeeping
	global $wpdb;
	$prefix = $wpdb->prefix;
	$homeurl = home_url();
	$imageurl = plugins_url('recent-post-views/');

/* NOTICE: Up next in a future version, options will be added for the widget. Also shortcode functionality. */

//Change this if you want the "recent" posts to be drawn from a different number of days
	$ndays = 2;
//Change this if you want the "hot" posts to be a different percentage of the max page views (currently at 75%)
	$hotLevel = .75;
//Change this if you want the font color for the "hot" posts to be different:
	$fontcolor = "#d5000";
	
$maxViews = $wpdb->get_row("SELECT SUM(".$prefix."postmeta.meta_value) as 'views'
FROM ".$prefix."postmeta
LEFT JOIN ".$prefix."posts ON ".$prefix."postmeta.post_id = ".$prefix."posts.ID
WHERE ".$prefix."postmeta.meta_key = 'views' AND ".$prefix."posts.post_type = 'post' AND ".$prefix."posts.post_date > DATE_SUB(CURDATE(), INTERVAL ".$ndays." DAY)
GROUP BY ".$prefix."posts.post_title
ORDER BY views DESC
LIMIT 1",ARRAY_A);

$postviews = $wpdb->get_results("SELECT ".$prefix."posts.post_date, ".$prefix."posts.ID, ".$prefix."posts.post_title, ".$prefix."posts.post_name, SUM(".$prefix."postmeta.meta_value) as 'views'
	FROM ".$prefix."postmeta
	LEFT JOIN ".$prefix."posts ON ".$prefix."postmeta.post_id = ".$prefix."posts.ID
	WHERE ".$prefix."postmeta.meta_key = 'views' AND ".$prefix."posts.post_type = 'post' AND ".$prefix."posts.post_date > DATE_SUB(CURDATE(), INTERVAL ".$ndays." DAY)
	GROUP BY ".$prefix."posts.post_title
	ORDER BY views DESC
	LIMIT 10",OBJECT);

foreach ($postviews as $widgetvalue) {
//Open the table and the list.
echo'<ul><table>';
echo'<li><tr><td>';

//if the post has the most views, include the "hottest" image.
if ($widgetvalue->views == $maxViews['views'])
	echo '<td><img src="'.$imageurl.'Hottest.png" width="25" height="9" align="top"></td><td><strong><a href="'.$homeurl.'/?p='.$widgetvalue->ID.'">'.$widgetvalue->post_title.'</a></strong> - <font color="'.$fontcolor.'">'.$widgetvalue->views.' views</font></td></tr>';

//if the post has more than the x% of the most views, include the "hot" image.
else if ($widgetvalue->views >= $hotLevel * $maxViews['views'])
	echo '<td><img src="'.$imageurl.'Hot.png" width="25" height="9" align="top"></td><td><strong><a href="'.$homeurl.'/?p='.$widgetvalue->ID.'">'.$widgetvalue->post_title.'</a></strong> - <font color="'.$fontcolor.'">'.$widgetvalue->views.' views</font></td></tr>';

//otherwise, just list the post with a link.
else
	echo '<td></td><td><strong><a href="'.$homeurl.'/?p='.$widgetvalue->ID.'">'.$widgetvalue->post_title.'</a></strong> - '.$widgetvalue->views.' views</td></tr>';

//Close the table and the list.
echo '</li>';
echo '</table></ul>';
}
	
    echo $after_widget;
  }
}
add_action( 'widgets_init', create_function('', 'return register_widget("recentPostViews_Widget");') );


?>